MineshaftFiller = {};

local TimerI = 0;
local MaxTimerI = g_gameSettings:getValue(GameSettings.SETTING.FRAME_LIMIT)/5;

local IronHeapX = -877.324707031;
local IronHeapY = 120;
local IronHeapZ = -305.960052490;

local RayX = 0;
local RayY = -1;
local RayZ = 0;

local AvaibleVehicle = nil;
local AvaibleFillIndex = nil;

function MineshaftFiller:Timer()
    TimerI = TimerI + 1;
    if TimerI < MaxTimerI then return false; end;
    TimerI = 0;
    return true;
end;

function MineshaftFiller:DistanceFrom(x1,y1,x2,y2) return math.sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2) end

function MineshaftFiller:IronHeapRaycastCallback(HitId)
    for _, vehicle in ipairs (g_currentMission.vehicles) do
        if vehicle.spec_fillUnit ~= nil then
            local FillUnitIndex = vehicle.spec_fillUnit:getFillUnitIndexFromNode(HitId);
            if FillUnitIndex ~= nil and vehicle:getFillUnits()[FillUnitIndex].supportedFillTypes[FillType.IRONORE] ~= nil  then 
                AvaibleFillIndex = FillUnitIndex;
                AvaibleVehicle = vehicle;
                return false;
            end;
        end;
    end

    AvaibleVehicle = nil;
    return true;
end;

function MineshaftFiller:update()	
    if not MineshaftFiller:Timer() then return; end;
    raycastAll(IronHeapX, IronHeapY, IronHeapZ, RayX, RayY, RayZ, "IronHeapRaycastCallback", 25, self);
end;

function MineshaftFiller:TransferIron(Amount)
    AvaibleVehicle:addFillUnitFillLevel(AvaibleVehicle:getOwnerFarmId(), AvaibleFillIndex, Amount, FillType.IRONORE, ToolType.UNDEFINED);
end;

function MineshaftFiller:tipToGroundAroundLine(superFunc,vehicle, amount, fillTypeIndex, x, y, z, x2, y2, z2, A1, A2, A3, A4, A5, A6, A7)
    if AvaibleVehicle ~= nil and amount == FillType.IRONORE and MineshaftFiller:DistanceFrom(IronHeapX,IronHeapZ,fillTypeIndex,y) < 1 then
        MineshaftFiller:TransferIron(vehicle); return vehicle,1;
    end;
    return superFunc(self,vehicle, amount, fillTypeIndex, x, y, z, x2, y2, z2, A1, A2, A3, A4, A5, A6, A7);
end;

DensityMapHeightUtil.tipToGroundAroundLine = Utils.overwrittenFunction(DensityMapHeightUtil.tipToGroundAroundLine, MineshaftFiller.tipToGroundAroundLine);
addModEventListener(MineshaftFiller);